﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Spire.Pdf;
using Spire.Pdf.Graphics;
using Spire.Pdf.Widget;

namespace SALESSUPPORT_2039
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string path = @"..\\..\\files";
            string newFileName = String.Format("{0}.pdf", Guid.NewGuid().ToString());
            string resultFilePath = String.Format("{0}" + "\\" + "{1}", path, newFileName);

            List<byte[]> files = new List<byte[]>();
            foreach (string file in Directory.EnumerateFiles(path, "*.pdf"))
            {
                files.Add(System.IO.File.ReadAllBytes(file));
            }
            List<PdfDocument> pdfDocs = new List<PdfDocument>();

            PdfDocument[] docs2 = new PdfDocument[files.Count];
            for (int i = 0; i < files.Count; i++)
                docs2[i] = new PdfDocument(files[i]);

            for (int i = 1; i < docs2.Length; i++)
                docs2[0].AppendPage(docs2[i]);

            if (files.Count == 0)
                docs2 = new PdfDocument[1] { new PdfDocument() };

            using (MemoryStream ms = new MemoryStream())
            {
                docs2[0].SaveToStream(ms);
                PdfDocument mergedPdf = new PdfDocument();

                //margin
                PdfUnitConvertor unitCvtr = new PdfUnitConvertor();
                PdfMargins margin = new PdfMargins();
                margin.Top = unitCvtr.ConvertUnits(2.54f, PdfGraphicsUnit.Centimeter, PdfGraphicsUnit.Point);
                margin.Bottom = margin.Top;
                margin.Left = unitCvtr.ConvertUnits(3.17f, PdfGraphicsUnit.Centimeter, PdfGraphicsUnit.Point);
                margin.Right = margin.Left;
                mergedPdf.PageSettings.Width = docs2[0].PageSettings.Width + margin.Left + margin.Right;
                mergedPdf.PageSettings.Height = docs2[0].PageSettings.Height + margin.Top + margin.Right;
                PdfSection sec = mergedPdf.Sections.Add();

                foreach (PdfPageBase page in docs2[0].Pages)
                {

                    PdfPageBase mergedPdfpage = sec.Pages.Add();

                    page.CreateTemplate().Draw(mergedPdfpage, 0, 0);
                }


                //add page number after merge
                DrawPageNumber(sec, margin, 1, sec.Pages.Count);

                //Add an Image page
                string imagepath = @"..\..\Background.png";
                DrawImagePage(sec, imagepath);

                mergedPdf.SaveToFile(resultFilePath, FileFormat.PDF);
            }

            MessageBox.Show("Finally!");

        }
        private void DrawPageNumber(PdfSection section, PdfMargins margin, int startNumber, int pageCount)
        {
            foreach (PdfPageBase page in section.Pages)
            {
                PdfBrush brush = PdfBrushes.Black;
                PdfPen pen = new PdfPen(brush, 0.75f);
                PdfTrueTypeFont font = new PdfTrueTypeFont(new Font("Arial", 9f, FontStyle.Italic), true);
                PdfStringFormat format = new PdfStringFormat(PdfTextAlignment.Right);
                format.MeasureTrailingSpaces = true;
                float space = font.Height * 0.75f;
                float x = margin.Left;
                float width = page.Canvas.ClientSize.Width - margin.Left - margin.Right;
                float y = page.Canvas.ClientSize.Height - margin.Bottom + space;
                page.Canvas.DrawLine(pen, x, y, x + width, y);
                y = y + 1;
                String numberLabel
                    = String.Format("{0} of {1}", startNumber++, pageCount);
                page.Canvas.DrawString(numberLabel, font, brush, x + width, y, format);
               
            }
        }
        private void DrawImagePage(PdfSection section, string imagepath) 
        {
            Image image = Image.FromFile(imagepath);

            //adjust image size
            int width = image.Width;
            int height = image.Height;
            float schale = 1.5f;
            Size size = new Size((int)(width * schale), (int)(height * schale));
            Bitmap schaleImage = new Bitmap(image, size);

            //insert image into the first PDF page at specific position
            PdfImage pdfImage = PdfImage.FromImage(schaleImage);
            PdfNewPage page = new PdfNewPage();
            section.Pages.Insert(0, page);

            PointF position = new PointF(0, 0);
            page.Canvas.DrawImage(pdfImage, position);
        }
    }
}
